## sord 0.4.2

=== wscript ===
#!/usr/bin/env python
import glob
import os

from waflib.extras import autowaf as autowaf
import waflib.Logs as Logs, waflib.Options as Options

# Version of this package (even if built as a child)
SORD_VERSION       = '0.4.2'
SORD_MAJOR_VERSION = '0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Sord uses the same version number for both library and package
SORD_LIB_VERSION = SORD_VERSION

# Variables for 'waf dist'
APPNAME = 'sord'
VERSION = SORD_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                   help="Build unit tests")
    opt.add_option('--dump', type='string', default='', dest='dump',
                   help="Dump debugging output (iter, search, write, all)")

def configure(conf):
    autowaf.configure(conf)
    conf.line_just = 32
    autowaf.display_header('Sord configuration')

    conf.load('compiler_cc')
    conf.env.append_value('CFLAGS', '-std=c99')

    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB',
                      atleast_version='2.0.0', mandatory=True)

    autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                      atleast_version='0.4.0', mandatory=True)

    conf.env['BUILD_TESTS'] = Options.options.build_tests
    conf.env['BUILD_UTILS'] = True

    dump = Options.options.dump.split(',')
    all = 'all' in dump
    if all or 'iter' in dump:
        autowaf.define(conf, 'SORD_DEBUG_ITER', 1)
    if all or 'search' in dump:
        autowaf.define(conf, 'SORD_DEBUG_SEARCH', 1)
    if all or 'write' in dump:
        autowaf.define(conf, 'SORD_DEBUG_WRITE', 1)

    autowaf.define(conf, 'SORD_VERSION', SORD_VERSION)
    conf.write_config_header('sord-config.h', remove=False)

    def fallback(var, val):
        conf.env[var] = val
        Logs.warn("Warning: %s unset, using %s\n" % (var, val))
        
    conf.env['INCLUDES_SORD'] = ['${includedir}/sord-%s' % SORD_MAJOR_VERSION]
    if not conf.env['INCLUDES_SERD']:
        fallback('INCLUDES_SERD', ['${includedir}/serd-0'])

    conf.env['LIBPATH_SORD'] = [conf.env['LIBDIR']]
    if not conf.env['LIBPATH_SERD']:
        fallback('LIBPATH_SERD', conf.env['LIBPATH_SORD'])

    conf.env['LIB_SORD'] = ['sord-%s' % SORD_MAJOR_VERSION];
    if not conf.env['LIB_SERD']:
        fallback('LIB_SERD', 'serd-0')

    autowaf.display_msg(conf, "Utilities", bool(conf.env['BUILD_UTILS']))
    autowaf.display_msg(conf, "Unit tests", bool(conf.env['BUILD_TESTS']))
    autowaf.display_msg(conf, "Debug dumping", dump)
    print('')

def build(bld):
    # C/C++ Headers
    includedir = '${INCLUDEDIR}/sord-%s/sord' % SORD_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('sord/*.h'))
    bld.install_files(includedir, bld.path.ant_glob('sord/*.hpp'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'SORD', SORD_VERSION, SORD_MAJOR_VERSION, 'SERD',
                     {'SORD_MAJOR_VERSION' : SORD_MAJOR_VERSION})

    # Library
    obj = bld(features        = 'c cshlib',
              source          = 'src/sord.c src/syntax.c',
              includes        = ['.', './src'],
              export_includes = ['.'],
              name            = 'libsord',
              target          = 'sord-%s' % SORD_MAJOR_VERSION,
              vnum            = SORD_LIB_VERSION,
              install_path    = '${LIBDIR}',
              libs            = [ 'm' ],
              cflags          = [ '-fvisibility=hidden',
                                  '-DSORD_SHARED',
                                  '-DSORD_INTERNAL' ])
    autowaf.use_lib(bld, obj, 'GLIB SERD')

    if bld.env['BUILD_TESTS']:
        test_cflags = [ '-fprofile-arcs',  '-ftest-coverage' ]

        # Static library (for unit test code coverage)
        obj = bld(features     = 'c cstlib',
                  source       = 'src/sord.c src/syntax.c',
                  includes     = ['.', './src'],
                  name         = 'libsord_static',
                  target       = 'sord_static',
                  install_path = '',
                  cflags       = test_cflags,
                  libs         = [ 'm' ])
        autowaf.use_lib(bld, obj, 'GLIB SERD')

        # Unit test program
        obj = bld(features     = 'c cprogram',
                  source       = 'src/sord_test.c',
                  includes     = ['.', './src'],
                  use          = 'libsord_static',
                  linkflags    = '-lgcov',
                  target       = 'sord_test',
                  install_path = '',
                  cflags       = test_cflags)
        autowaf.use_lib(bld, obj, 'GLIB SERD')

        # Static sordi build
        obj = bld(features = 'c cprogram')
        obj.source       = 'src/sordi.c'
        obj.includes     = ['.', './src']
        obj.use          = 'libsord_static'
        obj.linkflags    = '-lgcov'
        obj.target       = 'sordi_static'
        obj.install_path = ''
        obj.cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]

        # C++ build test
        obj = bld(features     = 'cxx cxxprogram',
                  source       = 'src/sordmm_test.cpp',
                  includes     = ['.', './src'],
                  use          = 'libsord_static',
                  linkflags    = '-lgcov',
                  target       = 'sordmm_test',
                  install_path = '',
                  cflags       = test_cflags)
        autowaf.use_lib(bld, obj, 'GLIB SERD')

    # Static command line utility (for testing)
        if bld.env['BUILD_UTILS']:
            obj = bld(features     = 'c cprogram',
                      source       = 'src/sordi.c',
                      includes     = ['.', './src'],
                      use          = 'libsord_static',
                      linkflags    = '-lgcov',
                      target       = 'sordi_static',
                      install_path = '',
                      cflags       = test_cflags)

    # Command line utility
    if bld.env['BUILD_UTILS']:
        obj = bld(features     = 'c cprogram',
                  source       = 'src/sordi.c',
                  includes     = ['.', './src'],
                  use          = 'libsord',
                  linkflags    = '-lgcov',
                  target       = 'sordi',
                  install_path = '${BINDIR}')

    # Documentation
    autowaf.build_dox(bld, 'SORD', SORD_VERSION, top, out)

    # Man page
    bld.install_files('${MANDIR}/man1', 'doc/sordi.1')

    bld.add_post_fun(autowaf.run_ldconfig)
    if bld.env['DOCS']:
        bld.add_post_fun(fix_docs)

def build_dir(ctx, subdir):
    if autowaf.is_child():
        return os.path.join('build', APPNAME, subdir)
    else:
        return os.path.join('build', subdir)
    
def fix_docs(ctx):
    try:
        top = os.getcwd()
        os.chdir(build_dir(ctx, 'doc/html'))
        os.system("sed -i 's/SORD_API //' group__sord.html")
        os.system("sed -i 's/SORD_DEPRECATED //' group__sord.html")
        os.remove('index.html')
        os.symlink('group__sord.html',
                   'index.html')
        os.chdir(top)
        os.chdir(build_dir(ctx, 'doc/man/man3'))
        os.system("sed -i 's/SORD_API //' sord.3")
        os.chdir(top)
    except:
        Logs.error("Failed to fix up %s documentation" % APPNAME)

def upload_docs(ctx):
    os.system("rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/sord/")

def test(ctx):
    blddir = build_dir(ctx, 'tests')
    try:
        os.makedirs(blddir)
    except:
        pass

    for i in glob.glob(blddir + '/*.*'):
        os.remove(i)

    srcdir   = ctx.path.abspath()
    orig_dir = os.path.abspath(os.curdir)

    os.chdir(srcdir)

    good_tests = glob.glob('tests/test-*.ttl')
    good_tests.sort()

    os.chdir(orig_dir)

    autowaf.pre_test(ctx, APPNAME)

    autowaf.run_tests(ctx, APPNAME, [
            './sordi_static file:%s/tests/manifest.ttl > /dev/null' % srcdir,
            './sordi_static file://%s/tests/manifest.ttl > /dev/null' % srcdir,
            './sordi_static %s/tests/UTF-8.ttl > /dev/null' % srcdir,
            './sordi_static -v > /dev/null',
            './sordi_static -h > /dev/null',
            './sordi_static -s "<foo> a <#Thingie> ." > /dev/null',
            './sordi_static /dev/null > /dev/null'],
                      0, name='sordi-cmd-good')

    autowaf.run_tests(ctx, APPNAME, [
            './sordi_static > /dev/null',
            './sordi_static ftp://example.org/unsupported.ttl > /dev/null',
            './sordi_static -i > /dev/null',
            './sordi_static -o > /dev/null',
            './sordi_static -z > /dev/null',
            './sordi_static -p > /dev/null',
            './sordi_static -c > /dev/null',
            './sordi_static -i illegal > /dev/null',
            './sordi_static -o illegal > /dev/null',
            './sordi_static -i turtle > /dev/null',
            './sordi_static /no/such/file > /dev/null'],
                      1, name='sordi-cmd-bad')

    autowaf.run_tests(ctx, APPNAME, ['./sord_test'])

    commands = []
    for test in good_tests:
        base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test
        commands += [ './sordi_static %s/%s \'%s\' > %s.out' % (srcdir, test, base_uri, test) ]

    autowaf.run_tests(ctx, APPNAME, commands, 0, name='good')

    Logs.pprint('BOLD', '\nVerifying turtle => ntriples')
    for test in good_tests:
        out_filename = test + '.out'
        cmp_filename = srcdir + '/' + test.replace('.ttl', '.out')
        if not os.access(out_filename, os.F_OK):
            Logs.pprint('RED', 'FAIL: %s output is missing' % test)
        else:
            out_lines = sorted(open(out_filename).readlines())
            cmp_lines = sorted(open(cmp_filename).readlines())
            if out_lines != cmp_lines:
                Logs.pprint('RED', 'FAIL: %s is incorrect' % out_filename)
            else:
                Logs.pprint('GREEN', 'Pass: %s' % test)

    autowaf.post_test(ctx, APPNAME)

=== debian/changelog ===
sord (0.4.2-1) unstable; urgency=low

  * Initial release. (Closes: #619426)

 -- Alessio Treglia <alessio@debian.org>  Thu, 26 May 2011 11:47:25 +0200

=== debian/control ===
Source: sord
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 doxygen,
 graphviz,
 libglib2.0-dev,
 libserd-dev (>= 0.4.0),
 pkg-config,
 python
Standards-Version: 3.9.2
Homepage: http://drobilla.net/software/sord/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/sord.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/sord.git

Package: libsord-0-0
Section: utils
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: sordi
Description: library for storing RDF data in memory
 Sord is a lightweight C library for storing Redland Resource
 Description Framework (RDF) data in memory.
 .
 Sord includes man pages for the library (man sord) and a
 simple command line utility (man sordi).

Package: libsord-dev
Section: libdevel
Architecture: all
Depends: libsord-0-0 (>= ${source:Version}),
 libsord-0-0 (<< ${source:Upstream-Version}+1~),
 libserd-dev,
 ${misc:Depends}
Suggests: libsord-doc
Recommends: pkg-config
Description: library for storing RDF data in memory (development files)
 Sord is a lightweight C library for storing Redland Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the development headers.

Package: sordi
Architecture: any
Section: text
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: library for storing RDF data in memory - sordi tool
 Sord is a lightweight C library for storing Redland Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the utility 'sordi'.

Package: libsord-doc
Section: doc
Architecture: all
Enhances: libsord-dev
Depends: ${misc:Depends}
Recommends: libjs-jquery
Description: library for storing RDF data in memory (documentation)
 Sord is a lightweight C library for storing Redland Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the developer's reference for sord.

Package: sord-dbg
Priority: extra
Section: debug
Architecture: any
Depends: libsord-0-0 (= ${binary:Version}),
 sordi (= ${binary:Version}),
 ${misc:Depends}
Description: library for storing RDF data in memory (debugging symbols)
 Sord is a lightweight C library for storing Redland Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the debugging symbols for sord.

=== debian/rules ===
#!/usr/bin/make -f

LDFLAGS+=-Wl,--as-needed
WAF = ./waf

%:
	dh $@

override_dh_auto_configure:
	$(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--strict \
		--debug \
		--docs

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) distclean
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_strip:
	dh_strip --dbg-package=sord-dbg

## sord 0.5.0

=== wscript ===
--- 
+++ 
@@ -1,12 +1,14 @@
 #!/usr/bin/env python
 import glob
 import os
+import subprocess
+import sys
 
 from waflib.extras import autowaf as autowaf
 import waflib.Logs as Logs, waflib.Options as Options
 
 # Version of this package (even if built as a child)
-SORD_VERSION       = '0.4.2'
+SORD_VERSION       = '0.5.0'
 SORD_MAJOR_VERSION = '0'
 
 # Library version (UNIX style major, minor, micro)
@@ -25,28 +27,30 @@
 out = 'build'
 
 def options(opt):
+    opt.load('compiler_c')
+    opt.load('compiler_cxx')
     autowaf.set_options(opt)
     opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                    help="Build unit tests")
     opt.add_option('--dump', type='string', default='', dest='dump',
                    help="Dump debugging output (iter, search, write, all)")
+    opt.add_option('--static', action='store_true', default=False, dest='static',
+                   help="Build static library")
 
 def configure(conf):
+    conf.load('compiler_c')
+    conf.load('compiler_cxx')
     autowaf.configure(conf)
-    conf.line_just = 32
     autowaf.display_header('Sord configuration')
 
-    conf.load('compiler_cc')
-    conf.env.append_value('CFLAGS', '-std=c99')
-
-    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB',
-                      atleast_version='2.0.0', mandatory=True)
+    conf.env.append_unique('CFLAGS', '-std=c99')
 
     autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
-                      atleast_version='0.4.0', mandatory=True)
+                      atleast_version='0.5.0', mandatory=True)
 
     conf.env['BUILD_TESTS'] = Options.options.build_tests
     conf.env['BUILD_UTILS'] = True
+    conf.env['BUILD_STATIC'] = Options.options.static
 
     dump = Options.options.dump.split(',')
     all = 'all' in dump
@@ -91,9 +95,15 @@
     autowaf.build_pc(bld, 'SORD', SORD_VERSION, SORD_MAJOR_VERSION, 'SERD',
                      {'SORD_MAJOR_VERSION' : SORD_MAJOR_VERSION})
 
-    # Library
+    source = 'src/sord.c src/syntax.c src/zix/hash.c src/zix/tree.c'
+
+    libflags = [ '-fvisibility=hidden' ]
+    if sys.platform == 'win32':
+        libflags = []
+
+    # Shared Library
     obj = bld(features        = 'c cshlib',
-              source          = 'src/sord.c src/syntax.c',
+              source          = source,
               includes        = ['.', './src'],
               export_includes = ['.'],
               name            = 'libsord',
@@ -101,67 +111,70 @@
               vnum            = SORD_LIB_VERSION,
               install_path    = '${LIBDIR}',
               libs            = [ 'm' ],
-              cflags          = [ '-fvisibility=hidden',
-                                  '-DSORD_SHARED',
-                                  '-DSORD_INTERNAL' ])
-    autowaf.use_lib(bld, obj, 'GLIB SERD')
+              cflags          = libflags + [ '-DSORD_SHARED',
+                                             '-DSORD_INTERNAL' ])
+    autowaf.use_lib(bld, obj, 'SERD')
+
+    # Static Library
+    if bld.env['BUILD_STATIC']:
+        obj = bld(features        = 'c cstlib',
+                  source          = source,
+                  includes        = ['.', './src'],
+                  export_includes = ['.'],
+                  name            = 'libsord_static',
+                  target          = 'sord-%s' % SORD_MAJOR_VERSION,
+                  vnum            = SORD_LIB_VERSION,
+                  install_path    = '${LIBDIR}',
+                  libs            = [ 'm' ],
+                  cflags          = [ '-DSORD_INTERNAL' ])
+        autowaf.use_lib(bld, obj, 'SERD')
 
     if bld.env['BUILD_TESTS']:
         test_cflags = [ '-fprofile-arcs',  '-ftest-coverage' ]
 
-        # Static library (for unit test code coverage)
+        # Static profiled library (for unit test code coverage)
         obj = bld(features     = 'c cstlib',
-                  source       = 'src/sord.c src/syntax.c',
-                  includes     = ['.', './src'],
-                  name         = 'libsord_static',
-                  target       = 'sord_static',
+                  source       = source,
+                  includes     = ['.', './src'],
+                  name         = 'libsord_profiled',
+                  target       = 'sord_profiled',
                   install_path = '',
                   cflags       = test_cflags,
                   libs         = [ 'm' ])
-        autowaf.use_lib(bld, obj, 'GLIB SERD')
+        autowaf.use_lib(bld, obj, 'SERD')
 
         # Unit test program
         obj = bld(features     = 'c cprogram',
                   source       = 'src/sord_test.c',
                   includes     = ['.', './src'],
-                  use          = 'libsord_static',
+                  use          = 'libsord_profiled',
                   linkflags    = '-lgcov',
                   target       = 'sord_test',
                   install_path = '',
                   cflags       = test_cflags)
-        autowaf.use_lib(bld, obj, 'GLIB SERD')
-
-        # Static sordi build
-        obj = bld(features = 'c cprogram')
-        obj.source       = 'src/sordi.c'
-        obj.includes     = ['.', './src']
-        obj.use          = 'libsord_static'
-        obj.linkflags    = '-lgcov'
-        obj.target       = 'sordi_static'
-        obj.install_path = ''
-        obj.cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]
+        autowaf.use_lib(bld, obj, 'SERD')
+
+        # Static profiled sordi build
+        obj = bld(features     = 'c cprogram',
+                  source       = 'src/sordi.c',
+                  includes     = ['.', './src'],
+                  use          = 'libsord_profiled',
+                  linkflags    = '-lgcov',
+                  target       = 'sordi_static',
+                  install_path = '',
+                  cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ])
+        autowaf.use_lib(bld, obj, 'SERD')
 
         # C++ build test
         obj = bld(features     = 'cxx cxxprogram',
                   source       = 'src/sordmm_test.cpp',
                   includes     = ['.', './src'],
-                  use          = 'libsord_static',
+                  use          = 'libsord_profiled',
                   linkflags    = '-lgcov',
                   target       = 'sordmm_test',
                   install_path = '',
                   cflags       = test_cflags)
-        autowaf.use_lib(bld, obj, 'GLIB SERD')
-
-    # Static command line utility (for testing)
-        if bld.env['BUILD_UTILS']:
-            obj = bld(features     = 'c cprogram',
-                      source       = 'src/sordi.c',
-                      includes     = ['.', './src'],
-                      use          = 'libsord_static',
-                      linkflags    = '-lgcov',
-                      target       = 'sordi_static',
-                      install_path = '',
-                      cflags       = test_cflags)
+        autowaf.use_lib(bld, obj, 'SERD')
 
     # Command line utility
     if bld.env['BUILD_UTILS']:
@@ -169,9 +182,9 @@
                   source       = 'src/sordi.c',
                   includes     = ['.', './src'],
                   use          = 'libsord',
-                  linkflags    = '-lgcov',
                   target       = 'sordi',
                   install_path = '${BINDIR}')
+        autowaf.use_lib(bld, obj, 'SERD')
 
     # Documentation
     autowaf.build_dox(bld, 'SORD', SORD_VERSION, top, out)
@@ -182,6 +195,9 @@
     bld.add_post_fun(autowaf.run_ldconfig)
     if bld.env['DOCS']:
         bld.add_post_fun(fix_docs)
+
+def lint(ctx):
+    subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/* serd/*', shell=True)
 
 def build_dir(ctx, subdir):
     if autowaf.is_child():

=== debian/changelog ===
sord (0.5.0-1) unstable; urgency=low

  * New upstream release:
    - Remove glib dependency
    - Add function sord_contains for checking for a triple pattern
    - Add function sord_write_iter for writing a queried range
    - Fix Sord::Namespaces::qualify to no longer chop prefixes
    - Add ability to build static library
  * Drop glib dependency.
  * Requires serd >= 0.5.0
  * Update symbols file.

 -- Alessio Treglia <alessio@debian.org>  Mon, 03 Oct 2011 13:16:09 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,7 @@
 Build-Depends: debhelper (>= 7.0.50~),
  doxygen,
  graphviz,
- libglib2.0-dev,
- libserd-dev (>= 0.4.0),
+ libserd-dev (>= 0.5.0),
  pkg-config,
  python
 Standards-Version: 3.9.2

## sord 0.5.0+dfsg0

=== debian/changelog ===
sord (0.5.0+dfsg0-2) unstable; urgency=low

  * Build with MultiArch.

 -- Alessio Treglia <alessio@debian.org>  Tue, 24 Jan 2012 11:02:44 +0100

sord (0.5.0+dfsg0-1) unstable; urgency=low

  [ Adrian Knoth ]
  * Drop all references to Redland.

  [ Alessio Treglia ]
  * Repack upstream tarball to get rid of waf blob (Closes: #654504).
  * Adjust the clean target to properly clean the sources tree.

 -- Alessio Treglia <alessio@debian.org>  Tue, 10 Jan 2012 01:53:10 +0100

=== debian/control ===
Source: sord
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>
Build-Depends: debhelper (>= 8.1.3~),
 doxygen,
 graphviz,
 libserd-dev (>= 0.5.0),
 pkg-config,
 python
Standards-Version: 3.9.2
Homepage: http://drobilla.net/software/sord/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/sord.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/sord.git

Package: libsord-0-0
Section: utils
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: sordi
Description: library for storing RDF data in memory
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 Sord includes man pages for the library (man sord) and a
 simple command line utility (man sordi).

Package: libsord-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsord-0-0 (= ${binary:Version}),
 libserd-dev,
 ${misc:Depends}
Suggests: libsord-doc
Recommends: pkg-config
Description: library for storing RDF data in memory (development files)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the development headers.

Package: sordi
Architecture: any
Section: text
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: library for storing RDF data in memory - sordi tool
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the utility 'sordi'.

Package: libsord-doc
Section: doc
Architecture: all
Enhances: libsord-dev
Depends: ${misc:Depends}
Recommends: libjs-jquery
Description: library for storing RDF data in memory (documentation)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the developer's reference for sord.

Package: sord-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Depends: libsord-0-0 (= ${binary:Version}),
 sordi (= ${binary:Version}),
 ${misc:Depends}
Description: library for storing RDF data in memory (debugging symbols)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the debugging symbols for sord.

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LDFLAGS+=-Wl,--as-needed
 WAF = ./waf
 
@@ -10,6 +11,7 @@
 	$(WAF) configure \
 		--prefix=/usr \
 		--mandir=/usr/share/man \
+		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		--strict \
 		--debug \
 		--docs
@@ -18,7 +20,8 @@
 	$(WAF)
 
 override_dh_auto_clean:
-	$(WAF) distclean
+	$(WAF) clean || true
+	find -name "*.pyc" -delete
 	dh_auto_clean
 
 override_dh_auto_install:

=== debian/watch ===
version=3
http://download.drobilla.net/sord-(.*)\.tar\.bz2

## sord 0.8.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -8,7 +8,7 @@
 import waflib.Logs as Logs, waflib.Options as Options
 
 # Version of this package (even if built as a child)
-SORD_VERSION       = '0.5.0'
+SORD_VERSION       = '0.8.0'
 SORD_MAJOR_VERSION = '0'
 
 # Library version (UNIX style major, minor, micro)
@@ -43,14 +43,25 @@
     autowaf.configure(conf)
     autowaf.display_header('Sord configuration')
 
-    conf.env.append_unique('CFLAGS', '-std=c99')
+    if conf.env['MSVC_COMPILER']:
+        conf.env.append_unique('CFLAGS',   ['-TP', '-MD'])
+        conf.env.append_unique('CXXFLAGS', ['-TP', '-MD'])
+    else:
+        conf.env.append_unique('CFLAGS', '-std=c99')
 
     autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
-                      atleast_version='0.5.0', mandatory=True)
+                      atleast_version='0.14.0', mandatory=True)
+    autowaf.check_pkg(conf, 'libpcre', uselib_store='PCRE', mandatory=False)
 
     conf.env['BUILD_TESTS'] = Options.options.build_tests
     conf.env['BUILD_UTILS'] = True
     conf.env['BUILD_STATIC'] = Options.options.static
+
+    # Check for gcov library (for test coverage)
+    if conf.env['BUILD_TESTS']:
+        conf.check_cc(lib='gcov',
+                      define_name='HAVE_GCOV',
+                      mandatory=False)
 
     dump = Options.options.dump.split(',')
     all = 'all' in dump
@@ -62,7 +73,7 @@
         autowaf.define(conf, 'SORD_DEBUG_WRITE', 1)
 
     autowaf.define(conf, 'SORD_VERSION', SORD_VERSION)
-    conf.write_config_header('sord-config.h', remove=False)
+    conf.write_config_header('sord_config.h', remove=False)
 
     def fallback(var, val):
         conf.env[var] = val
@@ -98,8 +109,12 @@
     source = 'src/sord.c src/syntax.c src/zix/hash.c src/zix/tree.c'
 
     libflags = [ '-fvisibility=hidden' ]
-    if sys.platform == 'win32':
+    libs     = [ 'm' ]
+    defines  = []
+    if bld.env['MSVC_COMPILER']:
         libflags = []
+        libs     = []
+        defines  = ['snprintf=_snprintf']
 
     # Shared Library
     obj = bld(features        = 'c cshlib',
@@ -110,7 +125,8 @@
               target          = 'sord-%s' % SORD_MAJOR_VERSION,
               vnum            = SORD_LIB_VERSION,
               install_path    = '${LIBDIR}',
-              libs            = [ 'm' ],
+              libs            = libs,
+              defines         = defines,
               cflags          = libflags + [ '-DSORD_SHARED',
                                              '-DSORD_INTERNAL' ])
     autowaf.use_lib(bld, obj, 'SERD')
@@ -125,12 +141,16 @@
                   target          = 'sord-%s' % SORD_MAJOR_VERSION,
                   vnum            = SORD_LIB_VERSION,
                   install_path    = '${LIBDIR}',
-                  libs            = [ 'm' ],
+                  libs            = libs,
                   cflags          = [ '-DSORD_INTERNAL' ])
         autowaf.use_lib(bld, obj, 'SERD')
 
     if bld.env['BUILD_TESTS']:
-        test_cflags = [ '-fprofile-arcs',  '-ftest-coverage' ]
+        test_libs   = libs
+        test_cflags = ['']
+        if bld.is_defined('HAVE_GCOV'):
+            test_libs   += ['gcov']
+            test_cflags += ['-fprofile-arcs', '-ftest-coverage']
 
         # Static profiled library (for unit test code coverage)
         obj = bld(features     = 'c cstlib',
@@ -139,8 +159,9 @@
                   name         = 'libsord_profiled',
                   target       = 'sord_profiled',
                   install_path = '',
+                  defines      = defines,
                   cflags       = test_cflags,
-                  libs         = [ 'm' ])
+                  lib          = test_libs)
         autowaf.use_lib(bld, obj, 'SERD')
 
         # Unit test program
@@ -148,9 +169,10 @@
                   source       = 'src/sord_test.c',
                   includes     = ['.', './src'],
                   use          = 'libsord_profiled',
-                  linkflags    = '-lgcov',
+                  lib          = test_libs,
                   target       = 'sord_test',
                   install_path = '',
+                  defines      = defines,
                   cflags       = test_cflags)
         autowaf.use_lib(bld, obj, 'SERD')
 
@@ -159,10 +181,11 @@
                   source       = 'src/sordi.c',
                   includes     = ['.', './src'],
                   use          = 'libsord_profiled',
-                  linkflags    = '-lgcov',
+                  lib          = test_libs,
                   target       = 'sordi_static',
                   install_path = '',
-                  cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ])
+                  defines      = defines,
+                  cflags       = test_cflags)
         autowaf.use_lib(bld, obj, 'SERD')
 
         # C++ build test
@@ -170,21 +193,23 @@
                   source       = 'src/sordmm_test.cpp',
                   includes     = ['.', './src'],
                   use          = 'libsord_profiled',
-                  linkflags    = '-lgcov',
+                  lib          = test_libs,
                   target       = 'sordmm_test',
                   install_path = '',
-                  cflags       = test_cflags)
-        autowaf.use_lib(bld, obj, 'SERD')
-
-    # Command line utility
+                  defines      = defines)
+        autowaf.use_lib(bld, obj, 'SERD')
+
+    # Command line utilities
     if bld.env['BUILD_UTILS']:
-        obj = bld(features     = 'c cprogram',
-                  source       = 'src/sordi.c',
-                  includes     = ['.', './src'],
-                  use          = 'libsord',
-                  target       = 'sordi',
-                  install_path = '${BINDIR}')
-        autowaf.use_lib(bld, obj, 'SERD')
+        for i in ['sordi', 'sord_validate']:
+            obj = bld(features     = 'c cprogram',
+                      source       = 'src/%s.c' % i,
+                      includes     = ['.', './src'],
+                      use          = 'libsord',
+                      target       = i,
+                      install_path = '${BINDIR}',
+                      defines      = defines)
+            autowaf.use_lib(bld, obj, 'SERD PCRE')
 
     # Documentation
     autowaf.build_dox(bld, 'SORD', SORD_VERSION, top, out)
@@ -197,7 +222,7 @@
         bld.add_post_fun(fix_docs)
 
 def lint(ctx):
-    subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/* serd/*', shell=True)
+    subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/*.* sord/* src/zix/*.*', shell=True)
 
 def build_dir(ctx, subdir):
     if autowaf.is_child():
@@ -211,9 +236,9 @@
         os.chdir(build_dir(ctx, 'doc/html'))
         os.system("sed -i 's/SORD_API //' group__sord.html")
         os.system("sed -i 's/SORD_DEPRECATED //' group__sord.html")
+        os.system("sed -i 's/href=\"doc\/style.css\"/href=\"style.css\"/' group__sord.html")
         os.remove('index.html')
-        os.symlink('group__sord.html',
-                   'index.html')
+        os.symlink('group__sord.html', 'index.html')
         os.chdir(top)
         os.chdir(build_dir(ctx, 'doc/man/man3'))
         os.system("sed -i 's/SORD_API //' sord.3")
@@ -246,36 +271,40 @@
 
     autowaf.pre_test(ctx, APPNAME)
 
+    os.environ['PATH'] = '.' + os.pathsep + os.getenv('PATH')
+
+    nul = os.devnull
+
     autowaf.run_tests(ctx, APPNAME, [
-            './sordi_static file:%s/tests/manifest.ttl > /dev/null' % srcdir,
-            './sordi_static file://%s/tests/manifest.ttl > /dev/null' % srcdir,
-            './sordi_static %s/tests/UTF-8.ttl > /dev/null' % srcdir,
-            './sordi_static -v > /dev/null',
-            './sordi_static -h > /dev/null',
-            './sordi_static -s "<foo> a <#Thingie> ." > /dev/null',
-            './sordi_static /dev/null > /dev/null'],
+            'sordi_static file://%s/tests/manifest.ttl > %s' % (srcdir, nul),
+            'sordi_static %s/tests/UTF-8.ttl > %s' % (srcdir, nul),
+            'sordi_static -v > %s' % nul,
+            'sordi_static -h > %s' % nul,
+            'sordi_static -s "<foo> a <#Thingie> ." file:///test > %s' % nul,
+            'sordi_static %s > %s' % (nul, nul)],
                       0, name='sordi-cmd-good')
 
     autowaf.run_tests(ctx, APPNAME, [
-            './sordi_static > /dev/null',
-            './sordi_static ftp://example.org/unsupported.ttl > /dev/null',
-            './sordi_static -i > /dev/null',
-            './sordi_static -o > /dev/null',
-            './sordi_static -z > /dev/null',
-            './sordi_static -p > /dev/null',
-            './sordi_static -c > /dev/null',
-            './sordi_static -i illegal > /dev/null',
-            './sordi_static -o illegal > /dev/null',
-            './sordi_static -i turtle > /dev/null',
-            './sordi_static /no/such/file > /dev/null'],
+            'sordi_static > %s' % nul,
+            'sordi_static ftp://example.org/unsupported.ttl > %s' % nul,
+            'sordi_static -i > %s' % nul,
+            'sordi_static -o > %s' % nul,
+            'sordi_static -z > %s' % nul,
+            'sordi_static -p > %s' % nul,
+            'sordi_static -c > %s' % nul,
+            'sordi_static -i illegal > %s' % nul,
+            'sordi_static -o illegal > %s' % nul,
+            'sordi_static -i turtle > %s' % nul,
+            'sordi_static /no/such/file > %s' % nul],
                       1, name='sordi-cmd-bad')
 
-    autowaf.run_tests(ctx, APPNAME, ['./sord_test'])
+    autowaf.run_tests(ctx, APPNAME, ['sord_test'])
 
     commands = []
     for test in good_tests:
-        base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test
-        commands += [ './sordi_static %s/%s \'%s\' > %s.out' % (srcdir, test, base_uri, test) ]
+        base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test.replace('\\', '/')
+        commands += [ 'sordi_static "%s" "%s" > %s.out' % (
+                os.path.join(srcdir, test), base_uri, test) ]
 
     autowaf.run_tests(ctx, APPNAME, commands, 0, name='good')

=== debian/changelog ===
sord (0.8.0~dfsg0-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches.
  * Refresh symbols.
  * Put in sord-dbg only symbols from libsord-0-0.
  * Bump debhelper requirement to 9.
  * Bump serd requirement to 0.14.0.
  * debian/watch: Mangles dfsg suffix.
  * Update Vcs-* fields.
  * Set tarball compression to xz
  * Update debian/copyright's format.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Fri, 20 Apr 2012 09:40:28 +0200

=== debian/control ===
Source: sord
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper (>= 9),
 doxygen,
 graphviz,
 libserd-dev (>= 0.14.0~dfsg0),
 pkg-config,
 python
Standards-Version: 3.9.3
Homepage: http://drobilla.net/software/sord/
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/sord.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/sord.git

Package: libsord-0-0
Section: utils
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 sordi
Description: library for storing RDF data in memory
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 Sord includes man pages for the library (man sord) and a
 simple command line utility (man sordi).

Package: libsord-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libserd-dev,
 libsord-0-0 (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 libsord-doc
Recommends:
 pkg-config
Description: library for storing RDF data in memory (development files)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the development headers.

Package: sordi
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: library for storing RDF data in memory - sordi tool
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the utility 'sordi'.

Package: libsord-doc
Section: doc
Architecture: all
Enhances:
 libsord-dev
Depends:
 ${misc:Depends}
Recommends:
 libjs-jquery
Description: library for storing RDF data in memory (documentation)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the developer's reference for sord.

Package: sord-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Depends:
 libsord-0-0 (= ${binary:Version}),
 ${misc:Depends}
Description: library for storing RDF data in memory (debugging symbols)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the debugging symbols for sord.

=== debian/rules ===
--- 
+++ 
@@ -28,4 +28,5 @@
 	$(WAF) install --destdir=$(CURDIR)/debian/tmp
 
 override_dh_strip:
-	dh_strip --dbg-package=sord-dbg
+	dh_strip -plibsord-0-0 --dbg-package=sord-dbg
+	dh_strip --remaining-packages
